<script lang="ts">
import Vue from 'vue';
import { IsMobileMixin } from '../../mixins';
import { Badge } from '../common/index.vue';

export default Vue.extend({
  name: 'Atlassian',
  components: {
    Badge,
  },
  mixins: [IsMobileMixin],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
});
</script>

<template>
  <section class="hero-wrapper">
    <SlpContainer class="container slp-my-md-48 slp-overflow-x-hidden">
      <SlpRow class="container__row">
        <SlpColumn :cols="7" class="text-column">
          <div class="text">
            <Badge
              v-if="data.badge"
              :badge="data.badge"
              :is-dark="data.isDark"
            />
            <SlpTypography
              variant="heading1-bold"
              tag="h1"
              class="slp-mb-8 header-text"
              >{{ data.title }}</SlpTypography
            >
            <div
              v-if="data.subtitle"
              class="text__span slp-mt-24"
              v-html="$md.render(data.subtitle)"
            ></div>
          </div>
          <div class="buttons slp-mt-32">
            <div v-if="data.primary_btn">
              <SlpButton
                variant="primary"
                class="slp-mb-8 button"
                :data-ga-name="data.primary_btn.data_ga_name"
                :data-ga-location="data.primary_btn.data_ga_location"
                :href="data.primary_btn.url"
                >{{ data.primary_btn.text }}
              </SlpButton>
            </div>
          </div>
        </SlpColumn>
        <SlpColumn :cols="5" class="image-column column">
          <div
            class="image-container"
            :class="{
              'image-container--bordered': data.image.bordered,
            }"
          >
            <img
              id="image-container__image"
              class="image"
              :class="{
                'image--bordered': data.image.bordered,
              }"
              :src="data.image.image_url"
              :alt="data.image.alt"
              loading="lazy"
            />
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
@media (min-width: $breakpoint-lg) {
  .buttons {
    display: flex;
    .button:first-child {
      margin-right: $spacing-8;
    }
  }
}

.hero-wrapper {
  overflow: hidden;
  position: relative;

  &__button {
    @media (max-width: $breakpoint-md) {
      width: 100%;
      justify-content: center;
      background-color: $color-surface-50;
    }
  }
}

.container {
  overflow: visible;
  margin-left: auto;
  margin-right: auto;
  max-width: 1170px;
  @media (max-width: $breakpoint-xl) {
    padding: 0 $spacing-16 $spacing-8 $spacing-16;
  }

  &__row {
    display: flex;
    align-items: center;
    justify-content: space-between;
    overflow: visible;
    position: relative;

    .buttons {
      @media (max-width: $breakpoint-md) {
        a {
          width: 100%;
          justify-content: center;
        }
      }
    }
  }

  .text__span {
    font-size: 24px;
    line-height: 32px;
    letter-spacing: -0.8px;
    @media (max-width: $breakpoint-lg) {
      font-size: 20px;
      line-height: 24px;
    }
  }

  .text-column {
    z-index: 2;
    transition: transform 0.1s ease;
    margin-bottom: $spacing-24;
    @media (min-width: $breakpoint-lg) {
      padding-right: $spacing-32;
    }
  }

  .image-column {
    z-index: 1;
    transition: transform 0.1s ease;
    @media (max-width: $breakpoint-md) {
      width: 100%;
    }
  }

  .image-container {
    display: flex;
    justify-content: right;

    @media (max-width: $breakpoint-md) {
      display: none;
    }

    &--alt {
      margin: $spacing-32 0;
      @media (min-width: $breakpoint-md) {
        padding: $spacing-48 0;
      }
    }
  }

  .image {
    border-radius: 4px 4px 180px 4px;
    object-fit: contain;
    max-width: 100%;

    &__wrapper {
      width: 100%;
      height: 100%;
      overflow: hidden;
    }

    &--alt {
      width: 100%;
      max-width: 70vw;
      @media (min-width: $breakpoint-sm) {
        width: 100%;
      }
      @media (min-width: $breakpoint-md) {
        width: 50vw;
      }
    }
  }
}
</style>
